TOP_DIR=
KERNEL_DIR=
OPTFLAGS=
ASFLAGS=-m440 -g
LDFLAGS=
CFLAGS=-Wall -I$(KERNEL_DIR) -nodefaultlibs -nostdlib -mcpu=440fp -g $(OPTFLAGS)
CPPFLAGS=-P -C -undef
CPP=$(CROSS_COMPILE)cpp
CC=$(CROSS_COMPILE)gcc
AS=$(CROSS_COMPILE)as
LD=$(CROSS_COMPILE)ld
BENCHNAME=

KERNEL_OBJS=\
$(KERNEL_DIR)/flash.o \
$(KERNEL_DIR)/intc.o \
$(KERNEL_DIR)/isr.o \
$(KERNEL_DIR)/mmu.o \
$(KERNEL_DIR)/start.o \
$(KERNEL_DIR)/timer.o \
$(KERNEL_DIR)/uart_lite.o

all: $(BENCHNAME).elf

clean:
	$(RM) $(BENCHNAME).elf \
              $(BENCHNAME).o \
              $(BENCHNAME).lds
# link
$(BENCHNAME).elf: $(BENCHNAME).lds $(BENCHNAME).o $(KERNEL_OBJS)
	$(LD) $(LDFLAGS) $(BENCHNAME).lds -o $@

# objects
$(BENCHNAME).o: $(BENCHNAME).c $(KERNEL_DIR)/flash.h $(KERNEL_DIR)/mmu.h $(KERNEL_DIR)/io.h
	$(CC) $(CFLAGS) -c $(BENCHNAME).c -o $@

# preprocessing
$(BENCHNAME).lds: $(TOP_DIR)/common.lds
	$(CPP) $(CPPFLAGS) -DBENCHNAME=$(BENCHNAME) -DKERNEL_DIR=$(KERNEL_DIR) $< -o $@
