#ifndef __FLASH_H__
#define __FLASH_H__

#include <inttypes.h>

// Autoselect addresses
#define MANUF_ID 0x000
#define DEV_ID1 0x001
#define DEV_ID2 0x00e
#define DEV_ID3 0x00f
#define SECTOR_PROTECT_VERIFY 0x002

// CFI addresses
#define CFI_Q 0x010
#define CFI_R 0x011
#define CFI_Y 0x012

typedef struct
{
	uint32_t size; /* device data storage byte size */
	unsigned int word_size; /* word size in bytes */
	uint32_t sector_size; /* sector size in bytes */
	void *data;    /* pointer to device data storage */
} flash_t;

void flash_init(flash_t *flash);

#endif
