#ifndef __IO_H__
#define __IO_H__

static inline void write8(void *p, uint8_t v)
{
	__asm__ volatile(
	// assembly
	"stbx %0, 0, %1\n"
	"mbar\n"
	// output
	: 
	// input
	: "r" (v)    // operand 0
	, "r" (p));    // operand 1
}

static inline uint8_t read8(void *p)
{
	uint16_t v;
	__asm__ volatile(
	// assembly
	"lbzx %0, 0, %1\n"
	"mbar\n"
	// output
	: "=r" (v)    // operand 0
	// input
	: "r" (p));  // operand 1
	return v;
}

static inline void write_big16(void *p, uint16_t v)
{
	__asm__ volatile(
	// assembly
	"sthx %0, 0, %1\n"
	"mbar\n"
	// output
	: 
	// input
	: "r" (v)    // operand 0
	, "r" (p));    // operand 1
}

static inline uint16_t read_big16(void *p)
{
	uint16_t v;
	__asm__ volatile(
	// assembly
	"lhzx %0, 0, %1\n"
	"mbar\n"
	// output
	: "=r" (v)    // operand 0
	// input
	: "r" (p));  // operand 1
	return v;
}

static inline void write_little16(void *p, uint16_t v)
{
	__asm__ volatile(
	// assembly
	"sthbrx %0, 0, %1\n"
	"mbar\n"
	// output
	: 
	// input
	: "r" (v)    // operand 0
	, "r" (p));    // operand 1
}

static inline uint16_t read_little16(void *p)
{
	uint16_t v;
	__asm__ volatile(
	// assembly
	"lhbrx %0, 0, %1\n"
	"mbar\n"
	// output
	: "=r" (v)    // operand 0
	// input
	: "r" (p));  // operand 1
	return v;
}

static inline void write_big32(void *p, uint32_t v)
{
	__asm__ volatile(
	// assembly
	"stwx %0, 0, %1\n"
	"mbar\n"
	// output
	: 
	// input
	: "r" (v)    // operand 0
	, "r" (p));    // operand 1
}

static inline uint32_t read_big32(void *p)
{
	uint32_t v;
	__asm__ volatile(
	// assembly
	"lwzx %0, 0, %1\n"
	"mbar\n"
	// output
	: "=r" (v)    // operand 0
	// input
	: "r" (p));  // operand 1
	return v;
}

static inline void write_little32(void *p, uint32_t v)
{
	__asm__ volatile(
	// assembly
	"stwbrx %0, 0, %1\n"
	"mbar\n"
	// output
	: 
	// input
	: "r" (v)    // operand 0
	, "r" (p));    // operand 1
}

static inline uint32_t read_little32(void *p)
{
	uint32_t v;
	__asm__ volatile(
	// assembly
	"lwbrx %0, 0, %1\n"
	"mbar\n"
	// output
	: "=r" (v)    // operand 0
	// input
	: "r" (p));  // operand 1
	return v;
}

#endif
