/***************************************************************************
 *                                                                         *
 *   copyright        : (C) 2011 Commissariat a l'Energie Atomique (CEA)   *
 *   author           : Gilles Mouchard                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "flash.h"
#include "io.h"
#include "uart_lite.h"
#include "intc.h"
#include <inttypes.h>

int main()
{
	uint16_t cfi_q, cfi_r, cfi_y;
	flash_t flash;
	
	intc_init();
	flash_init(&flash);
	uart_lite_init();
	
	/* CFI Entry command */
	PrintString("Write CFI entry command\n");
	write_little16((uint16_t *) flash.data + 0x55, 0x0098);

	/* multiple reads can be performed after entry */
	PrintString("Read Q: ");
	cfi_q = read_little16((uint16_t *) flash.data + CFI_Q); /* read Q */
	PrintString((cfi_q == 'Q') ? "OK" : "FAILED");
	PrintString("\n");
	PrintString("Read R: ");
	cfi_r = read_little16((uint16_t *) flash.data + CFI_R); /* read R */
	PrintString((cfi_r == 'R') ? "OK" : "FAILED");
	PrintString("\n");
	PrintString("Read Y: ");
	cfi_y = read_little16((uint16_t *) flash.data + CFI_Y); /* read Y */
	PrintString((cfi_y == 'Y') ? "OK" : "FAILED");
	PrintString("\n");
	/* CFI exit */
	PrintString("Exit CFI query mode (Write reset command)\n");
	write_little16((uint16_t *) flash.data + 0x000, 0x00F0); /* exit CFI query mode (write reset command) */
	PrintString("Test is finished\n");
	return 0;
}
